from sys import setrecursionlimit
import threading
setrecursionlimit(10 ** 9)
threading.stack_size(67108864)

def main():
    def dfs(gr, start, can, visited):
        if can == 0:
            return visited
            
        visited.add(start)
        
        for next in gr[start] - visited:
            dfs(gr, next, can - 1, visited)
            
        return visited
        
    n, m, k = map(int, input().split())
    gr = {}
    all_v = []

    for i in range(m):
        x, y = map(int, input().split())
        if x not in gr.keys():
            gr[x] = set([])
        if y not in gr.keys():
            gr[y] = set([])
        
        gr[x].add(y)
        gr[y].add(x)

    for i in range(1, n + 1):
        if i not in gr.keys():
            gr[i] = set([])
    visited = set()
    for i in range(k):
        p, h = map(int, input().split())
        visited = dfs(gr, p, h + 1, visited)
        all_v += list(visited)
            
        

    for i in range(len(all_v)):
        all_v[i] = str(all_v[i])


    all_v = list(set(all_v))
    all_v.sort()
    print(len(all_v))
    print(" ".join(all_v))

thread = threading.Thread(target=main)
thread.start()

    
    
    

